package com.gic.store.service;

import com.gic.store.dto.StoreFieldSelectDTO;
import com.gic.store.entity.TabStoreFieldSelect;
import com.github.pagehelper.Page;

/**
 * @author guojx
 * @date 2019/7/1 2:47 PM
 */
public interface StoreFieldSelectService {
    /**
     * 新增
     * @param storeFieldSelectDTO
     * @return
     */
    int save(StoreFieldSelectDTO storeFieldSelectDTO);

    /**
     * 查询下一个排序值的属性值
     * @param storeFieldId
     * @param sort
     * @return
     */
    TabStoreFieldSelect getNextSort(int storeFieldId, double sort);

    /**
     * 查询上一个排序值的属性值
     * @param storeFieldId
     * @param sort
     * @return
     */
    TabStoreFieldSelect getPrevSort(int storeFieldId, double sort);

    /**
     * 根据主键查询
     * @param storeFieldSelectId
     * @return
     */
    TabStoreFieldSelect getStoreFieldSelectById(int storeFieldSelectId);

    /**
     * 更新序号
     * @param storeFieldSelectId
     * @param sort
     * @return
     */
    int updateSortById(int storeFieldSelectId, double sort);

    /**
     * 置顶、置底，自定义序号
     * @param storeFieldSelectId
     * @param storeFieldId
     * @param setValue
     */
    void setStoreFieldSelectSort(int storeFieldSelectId, int storeFieldId, int setValue);

    int delete(int storeFieldSelectId);

    int edit(int storeFieldSelectId, String storeFieldSelectName, String storeFieldSelectCode);

    /**
     * 分页查询列表数据
     * @param storeFieldId
     * @param search
     * @param pageNum
     * @param pageSize
     * @return
     */
    Page<TabStoreFieldSelect> listStoreFieldSelect(int storeFieldId, String search, Integer pageNum, Integer pageSize);

    /**
     * 置底
     * @param storeFieldId
     * @param storeFieldSelectId
     */
    void sortBottom(int storeFieldId, int storeFieldSelectId);

    /**
     * 置顶
     * @param storeFieldId
     * @param storeFieldSelectId
     */
    void sortTopping(int storeFieldId, int storeFieldSelectId);

    double getMinSort(int storeFieldId);

    boolean isRepeatCode(Integer storeFieldId, Integer storeFieldSelectId, String storeFieldSelectCode);


    boolean isRepeatName(Integer storeFieldId, Integer storeFieldSelectId, String storeFieldSelectName);
}
